/****************************************************
   Tod Reynolds, Joshua Peng, and Pill Gun Park
   Variable Frequency Electrosense
****************************************************/

//***** Global Variables *****************************
import controlP5.*;
ControlP5 controlP5;
import processing.serial.*; 
Serial[] myPorts = new Serial[1];
PrintWriter output;

public int myColorRect = 200;
public int myColorBackground = 100;
float height = 700;
float width = 1000;
int index = 0;
PFont myfont;  //initializing our text font

int kk = 0;
boolean newdata = false;
int L = 512;
float freq1 = 0;
int a = 0;
int b = 0;
int step = 0;
float u2 = 0;
float u1 = 0;
float a1 = 0;
float a2 = 0;
float b1 = 0;
float b2 = 0;
boolean step1 = false;
boolean step2 = false;
boolean step3 = false;
boolean step4 = false;
float[] freq2 = new float[19];
float[] freq = new float[L];
float bx = width/3;
float by = height/3;
float[] recmag = new float[20];
float[] recphase = new float[20];
float[] sin1 = new float[L];
float[] sin2 = new float[L];
float[] nsin1 = new float[L];
float[] nsin2 = new float[L];
float[] sin1a = new float[L];
float[] sin2a = new float[L];
float[] msin1 = new float[L-3];
float[] msin2 = new float[L-3];
float magnitude_pic;
float phase_pic;
float phase_u2;
float magnitude;
float phase;
float abs_phase;
float abs_mag;
boolean calculated = false;
float location = 0;

float[] sfft1 = new float[L-1]; 
float[] sfft2 = new float[L-1];
float[] fftfreq = new float[L/2];
float[] fft1 = new float[L/2];
float[] fft2 = new float[L/2];
float[] fftphase1 = new float[L/2];
float[] fftphase2 = new float[L/2];
float[] mfftphase1 = new float[L/2];
float[] mfftphase2 = new float[L/2];
float[] mfft1 = new float[L/2];
float[] mfft2 = new float[L/2];
float[] real = new float[L];
float[] imag = new float[L];
float[] fftreal1 = new float[L/2];
float[] fftreal2 = new float[L/2];
float[] fftimag1 = new float[L/2];
float[] fftimag2 = new float[L/2];

char activate = 'A';
char calibrate = 'c';
char start = 't';
char stop = 'u';
char fwd = 'v';
char rev = 'w';
char accel = 'x';
char slow = 'y';
char move = 'a';
int finish = 0;
float prevAvg = 255;
float currentAvg = 0;

//***** Main Setup Function *********************************
void setup() {
  output = createWriter("bodeplotdata.txt"); 
  myfont = loadFont("ArialNarrow-10.vlw");
  textFont(myfont);
  background(30);
  frameRate(60);
  controlP5 = new ControlP5(this);
  InitSerial();
  smooth();
   
  //window setup and splitting it into several blocks (for the plots) using rect()
  size(int(width),int(height));
  fill(0);
  noStroke();
  rect(0,0,bx,by);
  rect(0,by,bx,by);
  rect(0,by*2,bx,by);
  rect(bx,0,bx,2*by);
  rect(2*bx,0,bx,2*by);
  rect(0,2*by,width,by);
  
  //creating inner blocks filled with white color inside the blocks we just created for the plots
  stroke(180);
  fill(255);
  rect(bx/10,by*2+(by/8),bx*4/5,by*3/4);
  rect(bx/10,by/8,bx*4/5,by*3/4);
  rect(bx/10,by+(by/8),bx*4/5,by*3/4);
  rect(bx+(bx/10),by/8,bx*4/5,by-(by/4));
  rect(bx+(bx/10),by+by/8,bx*4/5,by-(by/4));
  
  //drawing midlines in the plots
  stroke(180);
  line(bx+bx/2,by/8,bx+bx/2,by-by/8);
  line(bx+bx/2,by+by/8,bx+bx/2,2*by-by/8);
  line(bx+(bx/10),by/2,2*bx-bx/10,by/2);
  line(bx+(bx/10),3*by/2,2*bx-bx/10,3*by/2);
  
  //important variables used to draw the plots
  float bwidth = bx-bx/5;
  float bheight = by-by/4;
  float x = bx+bx/10;
  float y = by/2;
  float y2 = by*3/2;
  
  //semilogx magnitude - creating the log scale x axis for the magnitude bode plot
  noFill();
  stroke(180);
  rect(x+map((log(200)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(300)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(400)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(500)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(600)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(700)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(800)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(900)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  
  //semilogx phase - creating the log scale x axis for the phase bode plot
  noFill();
  stroke(180);
  rect(x+map((log(200)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(300)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(400)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(500)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(600)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(700)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(800)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(900)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  
  //magnitude semilogy - creating the log scale y axis for the magnitude bode plot
  line(x,y+map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(100000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(100000)/log(10),-100,100,-1*bheight/2,bheight/2));

  //phase shift angle lines - creating the linear scale y axis for the phase bode plot
  line(x,y2+map(90,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(90,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(180,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(180,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(270,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(270,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(360,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(360,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(90,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(90,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(180,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(180,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(270,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(270,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(360,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(360,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(450,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(450,-450,450,-1*bheight/2,bheight/2));
  
  //controlp5 buttons
  //controlP5.addSlider("Sensor Location",0,100,0,int(bx+bx/10),int(2*by+12),161,int(by/12)).setId(1);
  //controlP5.addSlider("Manual Actuator Control",0,100,0,int(bx+bx/10),int(height-35),161,int(by/12)).setId(2);
  controlP5.addButton("Calculate/Plot",activate,int(bx+bx/10),int(height-by/4),80,19).setId(3);
  controlP5.addButton("Calibrate",calibrate,int(bx+bx/10+81),int(height-by/4),80,19).setId(4);
  //controlP5.addButton("Identify",0,int(bx+bx/10),int(2*by+55),80,19).setId(5);
  //controlP5.addTextfield("Object Type",int(bx+bx/10),int(by*2+100),80,17).setId(6);
  //controlP5.addButton("Locate",location,int(bx+bx/10+81),int(2*by+55),80,19).setId(7);
  //controlP5.addNumberbox("Object Location",location,int(bx+bx/10+81),int(by*2+100),80,17).setId(8);
  controlP5.addButton("accelerate",accel,int(bx+bx/10+185),int(height-114),80,12).setId(9);
  controlP5.addButton("slow",slow,int(bx+bx/10+185),int(height-101),80,12).setId(10);
  controlP5.addButton("data acquisition",start,int(bx+bx/10+81),int(2*by+by/8),80,19).setId(11);
  controlP5.addButton("pause",stop,int(bx+bx/10+185),int(height-153),80,12).setId(12);
  controlP5.addButton("forward",fwd,int(bx+bx/10+185),int(height-140),80,12).setId(13);
  controlP5.addButton("reverse",rev,int(bx+bx/10+185),int(height-127),80,12).setId(14);
  //controlP5.addButton("reset",reset,int(bx+bx/10+180),int(height-165),80,12).setId(15);
  controlP5.addButton("activate",move,int(bx+bx/10),int(2*by+by/8),80,19).setId(16);
  
}

//***** Main Draw Function *************************************
void draw() {
  
  labels();  
  if (newdata == true && kk<19) {
    if (calculated == false && step4 == false) {
    delay(200);
    calc();   
    if(step1 == true) { sinewaves(); }
    if(step2 == true) { fftmagplot(); }
    if(step3 == true) { fftphaseplot(); }
    calculated = true;
    }
    if(kk<19 && calculated == true && step4 == true) {
    calculated = false;
    newdata = false;
    step1 = false;
    step2 = false;
    step3 = false;
    step4 = false;
    //myPorts[0].write(char(activate+kk));
    //println((char)activate+kk);
    println(kk);
    kk++;
    }
    if (kk==19) {
    bodecurve();
    record();
    newdata = false;
    delay(100);
    } 
  }
}

void labels() {
  fill(255);
  text("Frequency (Hz)",bx+140,2*by-5);
  text("100",bx+bx/10-5,2*by-17);
  text("1k",bx+bx/2-3,2*by-17);
  text("10k",2*bx-bx/10-5,2*by-17);
  text("Magnitude (dB)",bx+bx/10+2,by/8-2);
  text("Sent and Sensed Signals",bx/10+2,by/8-2);
  text("Phase (degrees)",bx+bx/10+2,by+by/8-3);
  text("FFT Magnitude - Check Linearity",bx/10+2,by+by/8-2);
  text("FFT Phase",bx/10+2,by*2+by/8-2);
  text("Phase Bode Plot",bx+bx/2,by-5);
  text("Magnitude Bode Plot",bx+bx/2,by+5);
  stroke(255);
  fill(255,0,0);
  ellipse(bx+bx/2-6,by-10,6,6);
  fill(0,0,128);
  ellipse(bx+bx/2-6,by,6,6);
  stroke(0);
  fill(255);
  text("0",bx+25,by/2+4);
  text("20",bx+20,by/2-13);
  text("40",bx+20,by/2-31);
  text("60",bx+20,by/2-48);
  text("80",bx+20,by/2-66);
  text("100",bx+17,by/2-82);
  text("-20",bx+17,by/2+22);
  text("-40",bx+17,by/2+39);
  text("-60",bx+17,by/2+57);
  text("-80",bx+17,by/2+74);
  text("-100",bx+12,by/2+91);
  text("0",bx+25,3*by/2+4);
  text("90",bx+20,3*by/2-13);
  text("180",bx+17,3*by/2-31);
  text("270",bx+17,3*by/2-48);
  text("360",bx+17,3*by/2-66);
  text("450",bx+17,3*by/2-84);
  text("-90",bx+17,3*by/2+22);
  text("-180",bx+12,3*by/2+39);
  text("-270",bx+12,3*by/2+57);
  text("-360",bx+12,3*by/2+74);
  text("-450",bx+12,3*by/2+91);
}

  void numberbox(int position) {
  println("a numberbox event. object location = "+position);
}

public void controlEvent(ControlEvent theEvent) {
  println("got a control event from controller with id "+theEvent.controller().id()+": "+theEvent.controller().value());
  switch(theEvent.controller().id()) {
    case(3):
    activate = (char)(theEvent.controller().value());
    println("activate");
    reinitializebp();
    kk++;
    myPorts[0].write(activate);
    break;
    case(4):
    calibrate = (char)(theEvent.controller().value());
    println(calibrate);
    myPorts[0].write(calibrate);
    //myPorts[0].write(calibrate);
    break;
    case(9):
    println("accel");
    myPorts[0].write(accel);
    break;
    case(10):
    println("slow");
    myPorts[0].write(slow);
    break;
    case(11):
    println("start");
    myPorts[0].write(start);
    kk++;
    break;
    case(12):
    println("stop");
    myPorts[0].write(stop);
    println(location);
    break;
    case(13):
    println("fwd");
    myPorts[0].write(fwd);
    break;
    case(14):
    println("rev");
    myPorts[0].write(rev);
    break;
    case(16):
    println("move");
    myPorts[0].write(move);
    break;
  }
}

//***** Communication with RS232 between processing and the PIC *******************

// initialize the serial port
void InitSerial() {
  // List all the available serial ports
  // you want the one that you plugged in
  println(Serial.list());

  String portList = Serial.list()[1];
  // this assumes the COM port you want is the first one, change the 0 to the place of your comport in the list that appears in the debug window
  myPorts[0] = new Serial(this, portList, 38400);

  // read bytes into a buffer until you get a linefeed (ASCII 10):
  myPorts[0].bufferUntil('\n');
}

// serial event, check which port generated the event, just in case there are more than 1 ports open
void serialEvent(Serial thisPort) { 
  // variable to hold the number of the port:
  int portNumber = -1;

  // iterate over the list of ports opened, and match the 
  // one that generated this event:
  for (int p = 0; p < myPorts.length; p++) {
    if (thisPort == myPorts[p]) {
      portNumber = p;
    }
  }

  // read the serial buffer until a newline appears
  String myString = thisPort.readStringUntil('\n');

  // if you got any bytes other than the newline
  if (myString != null) {
    
    myString = trim(myString); // ditch the newline

    // split the string at the spaces, save as integers
    float line_received[] = float(split(myString, ' '));
    
    // grab the data
    if ((line_received.length == 6) && (portNumber==0)){
      if (index >= L){
        index = 0;
        newdata = true; //Note that we use this “newdata” Boolean variable to ensure that once we start collecting data points, 
                        //we will finish collecting all 512 data points before we can use the data points for calculating and plotting in the other functions.
        for (int i=0;i<L;i++) {
        //The sin1[] and sin2{} arrays collect the mapped nsin1[] and nsin2[] values, respectively.  They are mapped according to the sine wave plotting window dimensions 
        sin1[i] = map(nsin1[i],min(nsin1)-300,max(nsin1)+300,-1*int(by*3/8),int(by*3/8));
        sin2[i] = map(nsin2[i],min(nsin2)-300,max(nsin2)+300,-1*int(by*3/8),int(by*3/8)); 
        }
      }
      freq[index] = line_received[0];
      nsin1[index] = line_received[1];
      nsin2[index] = line_received[2];
      real[index] = line_received[3];
      imag[index] = line_received[4];
      
      //There is a corresponding integer variable to “finish” called “halfinch” in the PIC code that counts the 37 half-inches 
      //that the sensor/emitter module can move along the water tank.  It is incremented each time after the module moves a half-inch forward.  
      //Right after the PIC finishes moving that half-inch, it needs to tell Processing that it is ready to start fft calculation 
      //and will begin to send data points over by sending this incremented “halfinch.”  Even though we just want to send “halfinch” over, 
      //when you send data via rs232, you must send all the information over.  So the PIC will first send out dummy data points plus an 
      //incremented “halfinch”.  It is compared to “finish,” “kk” is reset back to zero and the bode plots are cleared.
      if (line_received[5] > finish) {
        kk = 0;
        reinitializebp();
        finish = int(line_received[5]);
      }
      index++; 
    }
  }
} // end serialEvent


void calc()
{
        float zero1 = 0;
        float zero2 = 0;
        float max1 = 0; 
        float max2 = 0; 
        boolean foundzero1 = false;
        boolean foundzero2 = false;
        boolean foundzero1a = false;
        boolean foundzero2a = false;
        boolean foundzero1b = false;
        boolean foundzero2b = false;
        
        //First, the data in real[] and imag[] arrays are split up into four 256 point arrays to carry 
        //the real and imaginary components of the complex fft values of the emitted and sensed waves.
        for (int i=0;i<L/2;i++) {
        fftreal1[i] = real[i];        //real component of the fft of the emitted wave
        fftreal2[i] = real[i+L/2];    //real component of the fft of the sensed wave
        fftimag1[i] = imag[i];        //imaginary component of the fft of the emitted wave
        fftimag2[i] = imag[i+L/2];    //imaginary component of the fft of the sensed wave
        }
        
        //fft1[] and fft2[] hold the magnitude of the emitted and sensed wave, respectively
        //fftphase1[] and fftphase2[] hold the phase of the emitted and sensed wave, respectively
	for (int i=0;i<L/2;i++) {
        fft1[i] = sqrt(fftreal1[i]*fftreal1[i] + fftimag1[i]*fftimag1[i]);
        fft2[i] = sqrt(fftreal2[i]*fftreal2[i] + fftimag2[i]*fftimag2[i]);
        fftphase1[i] = atan2(fftimag1[i], fftreal1[i])*180/PI;
        fftphase2[i] = atan2(fftimag2[i], fftreal2[i])*180/PI;
	}
        
        //the first data point in the fft magnitude tends to be very high and not important, so eliminate this first value
        //by putting them in new arrays (sfft1[] and sfft2[]) that don't include the first value
        for (int i=0;i<(L/2)-1;i++)
	{
	sfft1[i] = fft1[i+1];
	sfft2[i] = fft2[i+1];
	}

        //finds the peak value the magnitude fft plot
	max1 = max(sfft1);
	max2 = max(sfft2);
        
        //finds the index of the peak value of the magnitude fft plot, the index (a and b) are used in the freq[] (frequency vector)
        //to find at what frequency this peak occurs
	for (int i=0;i<(L/2);i++) {
		if (fft1[i] == max1) {
			a = i;
		}	
		if (fft2[i] == max2) {
			b = i;
		}
	}
       
       //averages that last 4 points in the sinusoidal signals and puts them in new arrays (msin1[] and msin2[])
       for (int i=0;i<L-3;i++) {
          msin1[i] = (sin1[i]+sin1[i+1]+sin1[i+2]+sin1[i+3])/4;
          msin2[i] = (sin2[i]+sin2[i+1]+sin2[i+2]+sin2[i+3])/4;
        }

        //finds the mid point of the sine waves, note that this point is nonzero, the boolean variables "foundzero1" and "foundzero2"
        //are used to ensure that this calculation is not repeated again before this function has completed
        if(foundzero1 == false && foundzero2 == false) {
        zero1 = min(msin1)+((max(msin1)-min(msin1))/2);
        zero2 = min(msin1)+((max(msin1)-min(msin1))/2);
        foundzero1 = true;
        foundzero2 = true;
        }
        
        //algorithm for finding the zero/mid point of the sinewaves, the boolean variables "foundzero1a" and "foundzero2a"
        //are used to ensure that this calculation is not repeated again before this function has completed
        //"a1" is the first zero point found on the emitted wave, "b1" is the first zero point found on the sensed wave
        for(int i=5;i<L-3;i++) {
          if(foundzero1a == false&&(i+1<L-3)&&(abs(msin1[i]-zero1)<=abs(msin1[i+1]-zero1))&&(abs(msin1[i]-zero1)<=abs(msin1[i-1]-zero1))&&msin1[i-1]>msin1[i+1]) {
          a1 = i;
          foundzero1a = true;
          }
          if(foundzero2a == false&&(i+1<L-3)&&(abs(msin2[i]-zero2)<=abs(msin2[i+1]-zero2))&&(abs(msin2[i]-zero2)<=abs(msin2[i-1]-zero2))&&msin2[i-1]>msin2[i+1]) {
          b1 = i;
          foundzero2a = true;
          }
        }
        
        //algorithm for finding the next zero/mid point of the sinewaves, the boolean variables "foundzero1b" and "foundzero2b"
        //are used to ensure that this calculation is not repeated again before this function has completed
        //"a2" is the index of the second and next zero point found on the emitted wave
        for(int i=(int)a1+2;i<L-3;i++) {
          if(foundzero1b == false&&(i+1<L-3)&&(abs(msin1[i]-zero1)<=abs(msin1[i+1]-zero1))&&(abs(msin1[i]-zero1)<=abs(msin1[i-1]-zero1))&&msin1[i-1]>msin1[i+1]) {
          a2 = i;
          foundzero1b = true;
          }
        }
        
        //"b2" is the index of the next zero point found on the sensed wave after "a2" of the emitted wave
        for(int i=(int)a1+2;i<L-3;i++) {
          if(foundzero2b == false&&(i+1<L-3)&&(abs(msin2[i]-zero2)<=abs(msin2[i+1]-zero2))&&(abs(msin2[i]-zero2)<=abs(msin2[i-1]-zero2))&&msin2[i-1]>msin2[i+1]) {
          b2 = i;
          foundzero2b = true;
          }
        } 
        
         //u2 is the period, note that u2 is always calculated to be 16  
         //we are forcing "a2" to come after "b2"
         u2 = a2-a1;
         while(b2-a2>u2) { b2=b2-u2; }
        
        //magnitude and phase calculations
        //"magnitude," "abs_phase," and "phase_pic" are calculated from the fft
        //"wave_mag," "phase" and "phase_u2" are calculated from looking at the sine waves
        //unfortunately, magnitude_pic wouldn't work anyway since the "i (or j)" is eliminated, 
        //the imaginary component would just combine with the real component when added in the transfer function. 
        
        magnitude = max2/max1;
        abs_phase = fftphase2[b]-fftphase1[a];
        phase_u2 = (b2-a2)/u2*360;
        if(phase_u2 <-360) {phase_u2=phase_u2+360;}
        
        phase = phase_u2;
        //magnitude = max(nsin2)/max(nsin1);
        //magnitude_pic = abs((fftreal2[b]+fftimag2[b])/(fftreal1[a]+fftimag1[a]));
        phase_pic = 180+atan2((fftreal2[b]+fftimag2[b]),(fftreal1[a]+fftimag1[a]))*180/PI;
        
        //the frequency of the peak in the magnitude fft plot, "a" and "b" should be equal and so just "a" is used
        freq1 = freq[a];
        
        //displaying some of the calculation results
        fill(0);
        noStroke();
        rect(width-100,0,100,200);
        fill(255);
        text("abs_mag "+(float)magnitude,width-90,9);
        text("abs_phase "+abs_phase,width-90,18);
        text("tf_mag "+(int)magnitude_pic,width-90,27);
        text("tf_phase "+phase_pic,width-90,36);
        text("exp_freq "+(int)freq1,width-90,45);
        text("act_freq "+(int)kk,width-90,54);
        text("wave_mag "+(int)(max(nsin2)/max(nsin1)),width-90,63);
        text("u2 "+(int)u2,width-90,72);
        text("phase_u2 "+(float)phase,width-90,81);
        text("a1 "+a1,width-90,90);
        text("b1 "+b1,width-90,99);
        text("a2 "+(int)a2,width-90,108);
        text("b2 "+(int)b2,width-90,117);
        text("finish "+finish,width-90,126);
        
        //initializing expected frequency values in freq2[]
        freq2[0] = 100;
        freq2[1] = 200;
        freq2[2] = 300;
        freq2[3] = 400;
        freq2[4] = 500;
        freq2[5] = 600;
        freq2[6] = 700;
        freq2[7] = 800;
        freq2[8] = 900;
        freq2[9] = 1000;
        freq2[10] = 2000;
        freq2[11] = 3000;
        freq2[12] = 4000;
        freq2[13] = 5000;
        freq2[14] = 6000;
        freq2[15] = 7000;
        freq2[16] = 8000;
        freq2[17] = 9000;
        freq2[18] = 10000;
        
        //plotting points on the magnitude bode plot
        float bwidth = bx-bx/5;
        float bheight = by-by/4;
        float x0 = bx+bx/10;
        float ya = by/2;
        float dy = map(20*log(magnitude)/log(10),-100, 100, -1*bheight/2, bheight/2);
        float dx = map((log(freq2[kk])/log(10))-2,0,2,0,bwidth);
        stroke(0,0,128);
        strokeWeight(3);
        point(x0+dx, ya-dy);
        strokeWeight(1);
        
        //plotting points on the phase bode plot
        //float bwidth = bx-bx/5;
        //float bheight = by-by/4;
        //float x0 = bx+bx/10;
        float yb = by*3/2;
        float dx0 = map((log(freq2[kk])/log(10))-2,0,2,0,bwidth);
        float dy0 = map(phase, -450, 450, -1*bheight/2, bheight/2);
        stroke(255,0,0);
        strokeWeight(3);
        point(x0+dx0, yb-dy0);
        strokeWeight(1);
        
        //recording the magnitude and phase bode plot points of the current frequency
        recmag[kk] = magnitude;
        recphase[kk] = phase;

  //uncomment to display array values on the right side of the window, you can change the array variable and how many points in the array you want to see
  //right now we are displaying the first 128 points of the emitted and sensed sine waves
  /*        
   for (int k=0;k<=64;k++) { 
   fill(0);
   noStroke();
   rect(2*bx,8*k,220,8);
   fill(255);
   text(sin1[k],2*bx,8*k);
   text(sin1[k+64],2*bx+50,8*k);
   text(sin2[k],2*bx+100,8*k);
   text(sin2[k+64],2*bx+150,8*k);
 }
   for (int k=0;k<=64;k++) { 
   fill(0);
   noStroke();
   //rect(2*bx+150,8*k,10,8);
   fill(255);
   text(k,2*bx+200,8*k);
 }
 */
 step1 = true; //completed calc()
}

void sinewaves()
{   
  fill(255);
  noStroke();
  rect(bx/10+1,by/8+1,bx-bx/5-2,by-by/4-2);

 //plots the emitted sine wave in red
  strokeWeight(1);
  noFill();
  stroke(255, 0, 0);
  beginShape();
  for (int i=0;i<64;i++) {
    curveVertex(bx/10+5+i*L/64/2, by/2-msin1[i]);
  }
  endShape();
  
  //plots the sensed sine wave in blue
  strokeWeight(1);
  noFill();
  stroke(0, 0, 128);
  beginShape();
  for (int i=0;i<64;i++){
    curveVertex(bx/10+5+i*L/64/2, by/2-msin2[i]);
  }
  endShape(); 
  
  //displays vertical guidelines that hit the zero point measured in the emitted and sensed sine waves
  //displays a horizontal guideline that hits the peak of the sine waves and displays the value of the peak of both emitted and sensed waves
  stroke(255,0,0);
  line(bx/10+5+a2*L/64/2,by/8+1,bx/10+5+a2*L/64/2,by-by/8-1);
  stroke(0,0,128);
  line(bx/10+5+b2*L/64/2,by/8+1,bx/10+5+b2*L/64/2,by-by/8-1);
  stroke(173,90,166);
  line(bx/10+2,by/2,bx-bx/10-2,by/2);
  line(bx/10+2,by/2-max(msin1),bx-bx/10-2,by/2-max(msin1));
  line(bx/10+2,by/2-max(msin2),bx-bx/10-2,by/2-max(msin2));
  fill(255,0,0);
  text(max(msin1),bx/10+1+10,by/2-max(msin1)-3);
  fill(0,0,128);
  text(max(msin2),bx/10+1+40,by/2-max(msin2)-3);
  
  //displays the calculated phase shift and amplitude change
  fill(0);
  text("Phase Shift:",bx-bx/10-48,by/8+10);
  fill(173,90,166);
  text(int(phase)+" degrees",bx-bx/10-55,by/8+18);
  fill(0);
  text("Amplitude Change:",bx/10+5,by/8+10);
  fill(173,90,166);
  text((int)(100-magnitude*100)+"%",bx/10+5,by/8+18);
  fill(255,0,0);
  text("Sent",bx-bx/10-20,by-by/8-11);
  fill(0,0,128);
  text("Sensed",bx-bx/10-32,by-by/8-2);
 
 //uncomment to display array values on the right side of the window, you can change the array variable and how many points in the array you want to see
  //right now we are displaying the first 172 points of the emitted and sensed sine waves
 /*
 for (int k=0;k<=85;k++) { 
    fill(0);
    noStroke();
   rect(2*bx,8*k,100,8);
   fill(255);
   text(sin1[k],2*bx,8*k);
   text(sin2[k+86],2*bx+50,8*k);
 }
 for (int k=0;k<=85;k++) { 
    fill(0);
    noStroke();
   rect(2*bx+100,8*k,100,8);
   fill(255);
   text(sin1[k+86],2*bx+100,8*k);
   text(sin2[k+86],2*bx+150,8*k);
 }
 for (int k=0;k<=85;k++) { 
    fill(0);
    noStroke();
   rect(2*bx+200,8*k,10,8);
   fill(255);
   text(k,2*bx+200,8*k);
 }
 */
 step2 = true; //sinewaves() has finished
}

void fftmagplot() {
  
      //Plots a curve of the fft magnitude with vertical guidelines hitting the peak point which are the actual, 
      //calculated frequency of the emitted and sensed waves.  There is also a vertical guideline for the expected 
      //frequency of the emitted and sensed waves.  These frequency values should be equal at all times, 
      //but you will see that the actual frequencies deviate from the expected frequency a little.
      int flip = 9300;
      float line_a;
      float line_b;
      float line_c;
      
      //maps the values of fft1[] and fft2[] so that they are plotted within the plotting window
      for (int i=0;i<L/2;i++) {
      mfft1[i] = map(fft1[i],min(fft1),max(fft1),0,(by-by/8-4));
      mfft2[i] = map(fft2[i],min(fft2),max(fft2),0,(by-by/8-4));
      }
      
      //plotting of the fft magnitude curve
      fill(255);
      noStroke();
      rect(bx/10+1,by+by/8+1,bx-bx/5-2,by-by/4-2);
      
      strokeWeight(1);
      noFill();
      stroke(0,0,128);
      beginShape();     
  for (int i=0;i<(L/2);i++) {
    fftfreq[i] = map(freq[i],freq[0],freq[(L/2)-1],0,256);
    curveVertex(bx/10+5+fftfreq[i], by*2-bx/8-15-mfft1[i]);   
    }
      endShape();
      
      strokeWeight(1);
      noFill();
      stroke(255,0,0);
      beginShape();     
  for (int i=0;i<(L/2);i++) {
    fftfreq[i] = map(freq[i],freq[0],freq[(L/2)-1],0,256);
    curveVertex(bx/10+5+fftfreq[i], by*2-bx/8-15-mfft2[i]);   
    }
      endShape();   
     
     //adding guidelines
     line_a = map(freq[a],freq[1],freq[(L/2)-1],0,256);
     line_b = map(freq[b],freq[1],freq[(L/2)-1],0,256);
     line_c = map(freq2[kk],freq[1],freq[(L/2)-1],0,256);
     stroke(180); 
     line(bx/10+5+line_a,by+by/8+2,bx/10+5+line_a,2*by-(by/8+2));
     line(bx/10+5+line_b,by+by/8+2,bx/10+5+line_b,2*by-(by/8+2)); 
     line(bx/10+5+line_c,by+by/8+2,bx/10+5+line_c,2*by-(by/8+2)); 
     
     //the frequencies are displayed on the right side of the guidelines by default
     //the frequencies are dispalyed on the left side of the guidelines after they are greater than "flip"
     if(freq[a] > flip) {
     fill(0,0,128);
     text((int)freq[a],bx/10+5+line_a-27,by+by/8+10);
     }
     if(freq[b] > flip) {
     fill(255,0,0);
     text((int)freq[b],bx/10+5+line_b-27,by+by/8+18); 
     }
     if(freq2[kk] > flip) {
     fill(173,90,166);
     text((int)freq2[kk],bx/10+5+line_c-27,by+by/8+26); 
     }
     
     else {
     fill(0,0,128);
     text((int)freq[a],bx/10+5+line_a+3,by+by/8+10);
     fill(255,0,0);
     text((int)freq[b],bx/10+5+line_b+3,by+by/8+18); 
     fill(173,90,166);
     text((int)freq2[kk],bx/10+5+line_c+3,by+by/8+26); 
     }
     fill(255,0,0);
     text("Sent",bx-bx/10-20,2*by-by/8-11);
     fill(0,0,128);
     text("Sensed",bx-bx/10-32,2*by-by/8-2);

step3 = true; //fftmagplot() has finished
}

void fftphaseplot() {
      
      //Plots a curve of the fft phase with vertical guidelines of the actual, calculated frequency of the emitted and sensed waves.  
      //These are the same guidelines in fftmagplot().
      int flip = 9300;
      float line_a;
      float line_b;
      float line_c;
      
      //maps the values of fft1[] and fft2[] so that they are plotted within the plotting window
      for (int i=0;i<L/2;i++) {
      mfftphase1[i] = map(fftphase1[i],min(fftphase1)-300,max(fftphase1)+300,-(by/2-by/8-4),(by/2-by/8-4));
      mfftphase2[i] = map(fftphase2[i],min(fftphase2)-300,max(fftphase2)+300,-(by/2-by/8-4),(by/2-by/8-4));
      }
      
      //plotting of the fft phase curve
      fill(255);
      noStroke();
      rect(bx/10+1,by*2+by/8+1,bx-bx/5-2,by-by/4-2);
      
      strokeWeight(1);
      noFill();
      stroke(0,0,128);
      beginShape();     
  for (int i=0;i<(L/2);i++) {
    fftfreq[i] = map(freq[i],freq[0],freq[(L/2)-1],0,256);
    curveVertex(bx/10+5+fftfreq[i], by*2.5-mfftphase1[i]);   
    }
      endShape();
      
      strokeWeight(1);
      noFill();
      stroke(255,0,0);
      beginShape();     
  for (int i=0;i<(L/2);i++) {
    fftfreq[i] = map(freq[i],freq[0],freq[(L/2)-1],0,256);
    curveVertex(bx/10+5+fftfreq[i], by*2.5-mfftphase2[i]);   
    }
      endShape();   
     
     line_a = map(freq[a],freq[1],freq[(L/2)-1],0,256);
     line_b = map(freq[b],freq[1],freq[(L/2)-1],0,256);
     line_c = map(freq2[kk],freq[1],freq[(L/2)-1],0,256);
     stroke(180); 
     line(bx/10+5+line_a,2*by+by/8+2,bx/10+5+line_a,3*by-(by/8+2));
     line(bx/10+5+line_b,2*by+by/8+2,bx/10+5+line_b,3*by-(by/8+2)); 
     line(bx/10+5+line_c,2*by+by/8+2,bx/10+5+line_c,3*by-(by/8+2)); 
     
     //the frequencies are displayed on the right side of the guidelines by default
     //the frequencies are dispalyed on the left side of the guidelines after they are greater than "flip"
     if(freq[a] > flip) {
     fill(0,0,128);
     text((int)freq[a],bx/10+5+line_a-27,2*by+by/8+10);
     }
     if(freq[b] > flip) {
     fill(255,0,0);
     text((int)freq[b],bx/10+5+line_b-27,2*by+by/8+18); 
     }
     if(freq2[kk] > flip) {
     fill(173,90,166);
     text((int)freq2[kk],bx/10+5+line_c-27,2*by+by/8+26);  
     }
     
     else {
     fill(0,0,128);
     text((int)freq[a],bx/10+5+line_a+3,2*by+by/8+10);
     fill(255,0,0);
     text((int)freq[b],bx/10+5+line_b+3,2*by+by/8+18); 
     fill(173,90,166);
     text((int)freq2[kk],bx/10+5+line_c+3,2*by+by/8+26); 
     }
     fill(255,0,0);
     text("Sent",bx-bx/10-20,3*by-by/8-11);
     fill(0,0,128);
     text("Sensed",bx-bx/10-32,3*by-by/8-2);
     
step4 = true;  //fftphaseplot() has finished
}

void bodecurve() {
        
        //This function is run after all 19 different frequency sine waves are sent from the PIC and plotted.  
        //The main purposes of this function are to connect the magnitude and phase bode plot points plotted 
        //in calc() with a curve line and to display the magnitude and phase values at each frequency.
        float bwidth = bx-bx/5;
        float bheight = by-by/4;
        float x0 = bx+bx/10;
        float ya = by/2;
        float yb = by*3/2;
        noFill();
        float dy1 = map(20*log(recmag[0])/log(10),-100, 100, -1*bheight/2, bheight/2);
        float dx1 = map((log(freq2[0])/log(10))-2,0,2,0,bwidth);
        float dx2 = map((log(freq2[0])/log(10))-2,0,2,0,bwidth);
        float dy2 = map(recphase[0], -450, 450, -1*bheight/2, bheight/2);
        
        beginShape();
        curveVertex(x0+dx1, ya-dy1);
    for (int i=0;i<19;i++) {
        dy1 = map(20*log(recmag[i])/log(10),-100, 100, -1*bheight/2, bheight/2);
        dx1 = map((log(freq2[i])/log(10))-2,0,2,0,bwidth);
        stroke(0,0,128);
        curveVertex(x0+dx1, ya-dy1);
    }
    curveVertex(x0+dx1, ya-dy1);
    endShape();
    
         beginShape();
         curveVertex(x0+dx2, yb-dy2);
    for (int i=0;i<19;i++) {      
        dx2 = map((log(freq2[i])/log(10))-2,0,2,0,bwidth);
        dy2 = map(recphase[i], -450, 450, -1*bheight/2, bheight/2);
        stroke(255,0,0);
        curveVertex(x0+dx2, yb-dy2);
    }
    curveVertex(x0+dx2, yb-dy2);
     endShape();
    
   //display of magnitude bode plot values, phase bode plot values, and frequency values
   for (int k=0;k<19;k++) { 
   fill(0);
   noStroke();
   rect(2*bx,8*k,220,8);
   fill(255);
   text(recmag[k],2*bx,8*(k+1));
   text(recphase[k],2*bx+50,8*(k+1));
   text(freq2[k],2*bx+100,8*(k+1));
 }
 /*
   for (int k=0;k<19;k++) { 
   fill(0);
   noStroke();
   fill(255);
   text(k,2*bx+150,8*(k+1));
 }
 */
 
 
}

void reinitializebp() {
  
  //clears the bode plots by creating new rectangles and lines to cover up the current plots
  //uses the same code as in setup()
  fill(0);
  noStroke();
  rect(2*bx,0,150,2*by);
  
  stroke(180);
  fill(255);
  rect(bx+(bx/10),by/8,bx*4/5,by-(by/4));
  rect(bx+(bx/10),by+by/8,bx*4/5,by-(by/4));
  
  stroke(180);
  line(bx+bx/2,by/8,bx+bx/2,by-by/8);
  line(bx+bx/2,by+by/8,bx+bx/2,2*by-by/8);
  line(bx+(bx/10),by/2,2*bx-bx/10,by/2);
  line(bx+(bx/10),3*by/2,2*bx-bx/10,3*by/2);
  
  //bode plot magnitude
  float bwidth = bx-bx/5;
  float bheight = by-by/4;
  float x = bx+bx/10;
  float y = by/2;
  float y2 = by*3/2;
  
  //semilogx magnitude
  noFill();
  stroke(180);
  rect(x+map((log(200)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(300)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(400)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(500)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(600)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(700)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(800)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  rect(x+map((log(900)/log(10))-2,0,2,0,bwidth),by/8,bwidth/2,by-by/4);
  
  //semilogx phase
  noFill();
  stroke(180);
  rect(x+map((log(200)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(300)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(400)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(500)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(600)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(700)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(800)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  rect(x+map((log(900)/log(10))-2,0,2,0,bwidth),by+by/8,bwidth/2,by-by/4);
  
  //magnitude semilogy
  line(x,y+map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(10)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(100)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(1000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y-map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y-map(20*log(10000)/log(10),-100,100,-1*bheight/2,bheight/2));
  line(x,y+map(20*log(100000)/log(10),-100,100,-1*bheight/2,bheight/2),x+bwidth,y+map(20*log(100000)/log(10),-100,100,-1*bheight/2,bheight/2));

  //phase shift angle lines
  line(x,y2+map(90,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(90,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(180,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(180,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(270,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(270,-450,450,-1*bheight/2,bheight/2));
  line(x,y2+map(360,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2+map(360,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(90,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(90,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(180,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(180,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(270,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(270,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(360,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(360,-450,450,-1*bheight/2,bheight/2));
  line(x,y2-map(450,-450,450,-1*bheight/2,bheight/2),x+bwidth,y2-map(450,-450,450,-1*bheight/2,bheight/2));

}

void record() {
   
  float[] compare_m = new float[10];
  float[] compare_p = new float[10];
  float[] acrylic_m = new float[10];
  float[] plastic_m = new float[10];
  float[] grape_m = new float[10];
  float[] iron_m = new float[10];
  float[] aluminum_m = new float[10];
  float[] water_m = new float[10];
  float[] acrylic_p = new float[10];
  float[] plastic_p = new float[10];
  float[] grape_p = new float[10];
  float[] iron_p = new float[10];
  float[] aluminum_p = new float[10];
  float[] water_p = new float[10];
  
  //the following arrays are recorded magnitude and phase bode plot results, only the last 10 points (1000Hz to 10kHz), 
  //using different objects placed underneath the emitter/sensor module
  //this is the library by which we compare test results to determine the object type (object identification)
  //the object identification algorithm is as follows:
  //assuming that the module is as a position where the object is directly below, 
  //experimental results have shown that most deviations occur at higher frequencies. thus,
  //the following code will take compare the last 10 magnitude points (dB) and phase points 
  //(degrees) of the magnitude bode plot and phase bode plot, respectively (1000Hz to 10kHz)
  //with each corresponding point of all of the library arrays of different object type by taking the difference between each point.
  //we then take the absolute value of each difference and then find the average of the absolute value of the differences.  
  //the library bode plot array that the current bode plot is compared against with the smallest average corresponds to the object type.
  acrylic_m[0] = -8.461;
  acrylic_m[1] = -8.82;
  acrylic_m[2] = -9.424;
  acrylic_m[3] = -9.415;
  acrylic_m[4] = -9.58;
  acrylic_m[5] = -9.415;
  acrylic_m[6] = -9.58;
  acrylic_m[7] = -9.514;
  acrylic_m[8] = -9.699;
  acrylic_m[9] = -10.08;
  
  acrylic_p[0] = -202.5;
  acrylic_p[1] = -202.5;
  acrylic_p[2] = -202.5;
  acrylic_p[3] = -180;
  acrylic_p[4] = -157.5;
  acrylic_p[5] = -168;
  acrylic_p[6] = -157.5;
  acrylic_p[7] = -157.5;
  acrylic_p[8] = -135;
  acrylic_p[9] = -135;
  
  water_m[0] = -15.156;
  water_m[1] = -15.961;
  water_m[2] = -20.585;
  water_m[3] = -21.379;
  water_m[4] = -20.871;
  water_m[5] = -21.669;
  water_m[6] = -20.644;
  water_m[7] = -20.711;
  water_m[8] = -19.267;
  water_m[9] = -19.821;
  
  water_p[0] = -270;
  water_p[1] = -247.5;
  water_p[2] = -270;
  water_p[3] = -225;
  water_p[4] = -225;
  water_p[5] = -225;
  water_p[6] = -202.5;
  water_p[7] = -225;
  water_p[8] = -225;
  water_p[9] = -240;
  
  plastic_m[0] = -5.41;
  plastic_m[1] = -5.273;
  plastic_m[2] = -5.403;
  plastic_m[3] = -5.653;
  plastic_m[4] = -5.71;
  plastic_m[5] = -5.938;
  plastic_m[6] = -6.201;
  plastic_m[7] = -6.44;
  plastic_m[8] = -6.565;
  plastic_m[9] = -6.585;
  
  plastic_p[0] = -180;
  plastic_p[1] = -202.5;
  plastic_p[2] = -180;
  plastic_p[3] = -180;
  plastic_p[4] = -180;
  plastic_p[5] = -169.4;
  plastic_p[6] = -157.5;
  plastic_p[7] = -157.5;
  plastic_p[8] = -157.5;
  plastic_p[9] = -157.5;
  
  grape_m[0] = -9.867;
  grape_m[1] = -10.335;
  grape_m[2] = -11.046;
  grape_m[3] = -11.545;
  grape_m[4] = -11.709;
  grape_m[5] = -12.414;
  grape_m[6] = -12.698;
  grape_m[7] = -12.933;
  grape_m[8] = -13.398;
  grape_m[9] = -13.561;
  
  grape_p[0] = -225;
  grape_p[1] = -202.5;
  grape_p[2] = -202.5;
  grape_p[3] = -180;
  grape_p[4] = -157.5;
  grape_p[5] = -157.5;
  grape_p[6] = -157.5;
  grape_p[7] = -135;
  grape_p[8] = -157.5;
  grape_p[9] = -135;
  
  iron_m[0] = -8.124;
  iron_m[1] = -8.488;
  iron_m[2] = -8.593;
  iron_m[3] = -8.952;
  iron_m[4] = -9.178;
  iron_m[5] = -8.734;
  iron_m[6] = -9.284;
  iron_m[7] = -9.144;
  iron_m[8] = -9.801;
  iron_m[9] = -9.915;
  
  iron_p[0] = -337.5;
  iron_p[1] = -337.5;
  iron_p[2] = -337.5;
  iron_p[3] = -337.5;
  iron_p[4] = -315;
  iron_p[5] = -317.6;
  iron_p[6] = -315;
  iron_p[7] = -312;
  iron_p[8] = -315;
  iron_p[9] = -315;
  
  aluminum_m[0] = -24.326;
  aluminum_m[1] = -27.944;
  aluminum_m[2] = -27.813;
  aluminum_m[3] = -24.239;
  aluminum_m[4] = -22.545;
  aluminum_m[5] = -23.008;
  aluminum_m[6] = -22.589;
  aluminum_m[7] = -21.007;
  aluminum_m[8] = -21.224;
  aluminum_m[9] = -20.428;
  
  aluminum_p[0] = -270;
  aluminum_p[1] = -247.5;
  aluminum_p[2] = -315;
  aluminum_p[3] = -360;
  aluminum_p[4] = -315;
  aluminum_p[5] = -315;
  aluminum_p[6] = -292.5;
  aluminum_p[7] = -292.5;
  aluminum_p[8] = -270;
  aluminum_p[9] = -270;

 float logmag = 0;
 float where = map(finish,0,37,2.36,20.64);
 
 float compare_water_m = 0;
 float compare_acrylic_m = 0;
 float compare_iron_m = 0; 
 float compare_aluminum_m = 0;
 float compare_plastic_m = 0;
 float compare_grape_m = 0;
 
 float compare_water_p = 0;
 float compare_acrylic_p = 0;
 float compare_iron_p = 0; 
 float compare_aluminum_p = 0;
 float compare_plastic_p = 0;
 float compare_grape_p = 0;
   
   //computing the sum of the absolute value of the differences
 for(int i=0;i<10;i++) {
   compare_acrylic_m = compare_acrylic_m + abs(acrylic_m[i] - 20*log(recmag[i+9])/log(10));
   compare_water_m = compare_water_m + abs(water_m[i] - 20*log(recmag[i+9])/log(10));
   compare_grape_m = compare_grape_m + abs(grape_m[i] - 20*log(recmag[i+9])/log(10));
   compare_iron_m = compare_iron_m + abs(iron_m[i] - 20*log(recmag[i+9])/log(10));
   compare_plastic_m = compare_plastic_m + abs(plastic_m[i] - 20*log(recmag[i+9])/log(10));
   compare_aluminum_m = compare_aluminum_m + abs(aluminum_m[i] - 20*log(recmag[i+9])/log(10));
   
   compare_acrylic_p = compare_acrylic_p + abs(acrylic_p[i] - recphase[i+9]);
   compare_aluminum_p = compare_aluminum_p + abs(aluminum_p[i] - recphase[i+9]);
   compare_grape_p = compare_grape_p + abs(grape_p[i] - recphase[i+9]);
   compare_water_p = compare_water_p + abs(water_p[i] - recphase[i+9]);
   compare_iron_p = compare_iron_p + abs(iron_p[i] - recphase[i+9]);
   compare_plastic_p = compare_plastic_p + abs(plastic_p[i] - recphase[i+9]);
 }
 
 float[] identify_m = new float[6];
 float[] identify_p = new float[6];
 
   //dividing by 10 to get the average
  identify_m[0] = compare_water_m/10;
  identify_m[1] = compare_acrylic_m/10;
  identify_m[2] = compare_iron_m/10;
  identify_m[3] = compare_aluminum_m/10;
  identify_m[4] = compare_plastic_m/10;
  identify_m[5] = compare_grape_m/10;
 
  identify_p[0] = compare_water_p/10;
  identify_p[1] = compare_acrylic_p/10;
  identify_p[2] = compare_iron_p/10; 
  identify_p[3] = compare_aluminum_p/10;
  identify_p[4] = compare_plastic_p/10;
  identify_p[5] = compare_grape_p/10;
  
  //finding which array had the smallest average, by putting all 6 object type averages into 2 arrays, 
  //"identify_m" (for magnitude) and "identify_p" (for phase), respectively.
  //then we find the minimum of the 2 arrays using min() and put that value into "choose_m" (for magnitude)
  //and "choose_p" (for phase).  a for loop is used to run through the values of the "identify_m" and "identify_p" arrays
  //until there is a match between "choose_m" and "identify_m[i]" and "choose_p" and "identify_p[i]" where "i" is the index
  //of the arrays.  the index "i" then determines the object type, one for magnitude and one for phase.
  float choose_m = min(identify_m);
  float choose_p = min(identify_p);
  float identify1 = 0;
  float identify2 = 0;
  
  for(int i=0;i<6;i++) {
   if(choose_m == identify_m[i]) {
     identify1 = i;
   }
  }
  
    for(int i=0;i<6;i++) {
   if(choose_p == identify_p[i]) {
     identify2 = i;
   }
  }
  text("0: water, no object",bx+bx/10,by*2+101);
  text("1: acrylic",bx+bx/10,by*2+110);
  text("2: iron",bx+bx/10,by*2+119);
  text("3: aluminum",bx+bx/10,by*2+128);
  text("4: plastic",bx+bx/10,by*2+137);
  text("5: grape",bx+bx/10,by*2+146);
  
  noStroke();
  fill(0);
  rect(bx+bx/10,by*2+63,200,27);
  fill(255);
 text("object type (derived from magnitude): "+int(identify1),bx+bx/10,by*2+72);
  text("object type (derived from phase): "+int(identify2),bx+bx/10,by*2+81);
   
   
   //the following code describes how we determine where the object is in the water tank (object detection)
   //the object detection algorithm is as follows:
   //assuming that the object is placed somewhere in the tank along the path of the emitter/sensor module and not shifted 
   //out perpendicularly from the module and the module has scanned at least a length covering a distance starting 
   //before reaching the object (at least 1 halfinch before), directly above the object, and after moving past the object (at least 1 halfinch after),
   //experimental results have shown that all magnitude bode plot curves, especially at higher frequencies, will continue or start to decrease, 
   //but when the module is directly above the object, the magnitude bode plot curve will have the greatest values.
   //we find the curve with the maximum magnitude bode plot points and then look at where we are in the tank by counting many times we have moved
   //(each time we move, we move a halfinch) to determine the object location.
   
   //each time this program is run, it creates a text file ("bodeplotdata.txt") in the folder where this sketch is located and records the step (how many halfinches the 
   //module has moved), location (where the module is according to the hashes etched on the back of the water tank), frequency (of voltage sine waves sent out), 
   //magnitude (in dB, at each frequency), and phase (in degrees, at each frequency)
   for (int k=0;k<19;k++) {
     logmag = 20*log(recmag[k])/log(10);
   output.println("step: "+nf(finish,2,0)+" | location: "+nf(where,2,2)+" | frequency: "+nf(freq2[k],5,0)+" | magnitude: "+nfp(logmag,2,3)+ " | phase: " +nfp(recphase[k],3,1)); 
   }
   
   //since all magnitude bode plots decrease in magnitude and each magnitude point is either 0dB or less, at the current position, we take the absolute value
   //of each magnitude (dB) point (0Hz to 10kHz), then take the average, and if the current average of the current position is less than the previous average
   //at a previous position, we have found that the object is directly below the module.
   for(int k=1;k<19;k++){
       currentAvg = currentAvg + abs(20*log(recmag[k])/log(10));
     }
      currentAvg = currentAvg/19;
      println("currentAvg");
      println(currentAvg);
      //currentAvg = abs(k);
      if (currentAvg < prevAvg){
          prevAvg = currentAvg; 
          location = where;
          println("location");
          println(location);
      }
      
      text("object @ "+location+" inches",bx+bx/10,by*2+90);
      
    output.println(" ");
    output.flush();
     if (finish >=37) { // Writes the remaining data to the file
     output.close(); // Finishes the file
     }
     smooth();
}
